{{page-title @model.dataBinding.name " | " (capitalize (t "edit"))}}

{{#if (or this.fastboot.isFastBoot (not @model))}}
  <LoadingContainer />
{{else}}
  <div class="d-flex min-h-100">
    <Manage::SideBar class="order-last flex-shrink-1">
      <Manage::ModelInfo @editablePanel={{this.editableField}} @savingPanel={{this.savingField}} @model={{@model.dataBinding}} @onSave={{this.save}} @onCancel={{this.cancel}} @onEdit={{this.edit}} />

      <div class="bottom pb-3 text-center">
        <Manage::SideBarGroup>
          <Manage::DeleteButton @onDelete={{this.delete}} @modelName="data-binding" @name={{@model.dataBinding.name}} />
        </Manage::SideBarGroup>
      </div>
    </Manage::SideBar>

    <Manage::Container {{did-insert this.updateIcons}} @title={{capitalize (t "edit data binding")}} @breadcrumbs={{this.breadcrumbs}}>
      <:content>
        <Manage::Row @name="name">
          <Manage::Text
            @title={{capitalize (t "name")}}
            @isMainValue={{true}}
            @value={{@model.dataBinding.name}}
            @emptyError={{capitalize (t "this data binding has no name")}}
            @editablePanel={{this.editableField}}
            @savingPanel={{this.savingField}}
            @onSave={{fn this.save "name"}}
            @onEdit={{this.edit}}
            @onCancel={{this.cancel}}
          />
        </Manage::Row>

        <Manage::Row @name="destination">
          <Input::Manage::DataBinding::Destination
            @title={{capitalize (t "destination")}}
            @isMainValue={{true}}
            @value={{@model.dataBinding.destination}}
            @team={{@model.dataBinding.visibility.team}}
            @editablePanel={{this.editableField}}
            @savingPanel={{this.savingField}}
            @onSave={{fn this.save "destination"}}
            @onEdit={{this.edit}}
            @onCancel={{this.cancel}}
          />
        </Manage::Row>

        <Manage::Row @name="connection-info">
          <Input::Manage::DataBinding::ConnectionInfo
            @title={{capitalize (t "connection info")}}
            @isMainValue={{true}}
            @value={{@model.dataBinding.connection}}
            @editablePanel={{this.editableField}}
            @savingPanel={{this.savingField}}
            @onSave={{fn this.save "connection"}}
            @onEdit={{this.edit}}
            @onCancel={{this.cancel}}
          />
        </Manage::Row>

        <Manage::Row @name="fields">
          <Input::Manage::DataBinding::FieldMapping
            @title={{capitalize (t "fields")}}
            @value={{@model.dataBinding.fields}}
            @editablePanel={{this.editableField}}
            @savingPanel={{this.savingField}}
            @onSave={{fn this.save "fields"}}
            @onEdit={{this.edit}}
            @onCancel={{this.cancel}}
          />
        </Manage::Row>

        <Manage::Row @name="description-template">
          <Manage::Text
            @title={{capitalize (t "description template")}}
            @isMainValue={{true}}
            @useTextArea={{true}}
            @value={{@model.dataBinding.descriptionTemplate}}
            @renderAsCode={{true}}
            @editablePanel={{this.editableField}}
            @savingPanel={{this.savingField}}
            @onSave={{fn this.save "descriptionTemplate"}}
            @onEdit={{this.edit}}
            @onCancel={{this.cancel}}
          />
        </Manage::Row>

        <Manage::Row @name="icons">
          <h2 class="capitalize-first-letter">
            {{capitalize (t "extra icons")}}

            {{#if this.savingIcons}}
              <FaIcon @icon="spinner" @spin={{true}} />
            {{/if}}
          </h2>

          <Input::Icons::List @disabled={{this.disabled}} @icons={{this.icons}} @value={{@model.dataBinding.extraIcons}} @onChange={{fn this.save "extraIcons"}} />
        </Manage::Row>

        <Manage::Row @name="update-by">
          <Manage::Text
            @title={{capitalize (t "Update by")}}
            @isMainValue={{true}}
            @value={{@model.dataBinding.updateBy}}
            @options={{this.updateFieldList}}
            @emptyError={{capitalize (t "All records will be added as new.")}}
            @editablePanel={{this.editableField}}
            @savingPanel={{this.savingField}}
            @onSave={{fn this.save "updateBy"}}
            @onEdit={{this.edit}}
            @onCancel={{this.cancel}}
          />
        </Manage::Row>

        <Manage::Row @name="crs">
          <Manage::Text
            @title={{capitalize (t "CRS")}}
            @isMainValue={{true}}
            @value={{@model.dataBinding.crs}}
            @emptyError={{capitalize (t "The mercator CRS will be used.")}}
            @editablePanel={{this.editableField}}
            @savingPanel={{this.savingField}}
            @onSave={{fn this.save "crs"}}
            @onEdit={{this.edit}}
            @onCancel={{this.cancel}}
          />
        </Manage::Row>
      </:content>
    </Manage::Container>
  </div>
{{/if}}